package com.ruoyi.common.utils;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.security.core.Authentication;
import org.springframework.security.core.context.SecurityContextHolder;
import org.springframework.security.crypto.bcrypt.BCryptPasswordEncoder;

import com.ruoyi.common.constant.HttpStatus;
import com.ruoyi.common.core.domain.model.LoginUser;
import com.ruoyi.common.exception.ServiceException;

/**
 * 安全服务工具类
 * 
 * @author ruoyi
 */
public class SecurityUtils {
	
	private static final Logger logger = LoggerFactory.getLogger(SecurityUtils.class);
	
	public static void main(String[] args) {
		String pwd="admin123";
		String pwd2=encryptPassword(pwd);
		System.out.println(pwd2);
		boolean res=matchesPassword(pwd, pwd2);
		System.out.println(res);
		
		String pwd3="$2a$10$7JB720yubVSZvUI0rEqK/.VqGOZTH.ulu33dHOiBE8ByOhJIrdAu2";
		boolean res2=matchesPassword(pwd, pwd3);
		System.out.println(res2);
	}
	
	
	public static boolean isCityManagerRole() {
		try {
			return isCityManagerRole(getLoginUser().getCurrLoginRole().getRoleKey());
		} catch (Exception e) {
			logger.debug("判断当前登录用户是否为城市管理员时失败,"+e.getMessage(),e);
			return false;
		}
	}
	
	public static boolean isNeedFilterByCityCode() {
		return needFilterByCityCode()!=null;
	}
	
	public static String needFilterByCityCode() {
		if(!isCityManagerRole()) {
			return null;
		}
		if(getLoginUser().getCurrLoginDept()==null) {
			return null;
		}
		String cityCode=getLoginUser().getCurrLoginDept().getDeptCode();
		if(StringUtils.isBlank(cityCode)) {
			return null;
		}
		return cityCode;
		
	}
	public static boolean isCityManagerRole(String roleKey) {
		if ("city_manager".equals(roleKey) ) {
			return true;
		} 
		return false;
	}
	
	
	
	/**
	 * 用户ID
	 **/
	public static Long getUserId() {
		try {
			return getLoginUser().getUserId();
		} catch (Exception e) {
			throw new ServiceException("获取用户ID异常", HttpStatus.UNAUTHORIZED);
		}
	}

	/**
	 * 获取部门ID
	 **/
	public static Long getDeptId() {
		try {
			return getLoginUser().getDeptId();
		} catch (Exception e) {
			throw new ServiceException("获取部门ID异常", HttpStatus.UNAUTHORIZED);
		}
	}

	/**
	 * 获取用户账户
	 **/
	public static String getUsername() {
		try {
			return getLoginUser().getUsername();
		} catch (Exception e) {
			throw new ServiceException("获取用户账户异常", HttpStatus.UNAUTHORIZED);
		}
	}

	/**
	 * 获取用户姓名
	 **/
	public static String getUserNickName() {
		try {
			return getLoginUser().getUser().getNickName();
		} catch (Exception e) {
			throw new ServiceException("获取用户姓名异常", HttpStatus.UNAUTHORIZED);
		}
	}

	/**
	 * 获取用户
	 **/
	public static LoginUser getLoginUser() {
		try {
			return (LoginUser) getAuthentication().getPrincipal();
		} catch (Exception e) {
			throw new ServiceException("获取用户信息异常", HttpStatus.UNAUTHORIZED);
		}
	}

	/**
	 * 获取Authentication
	 */
	public static Authentication getAuthentication() {
		return SecurityContextHolder.getContext().getAuthentication();
	}

	/**
	 * 生成BCryptPasswordEncoder密码
	 *
	 * @param password 密码
	 * @return 加密字符串
	 */
	public static String encryptPassword(String password) {
		BCryptPasswordEncoder passwordEncoder = new BCryptPasswordEncoder();
		return passwordEncoder.encode(password);
	}

	/**
	 * 判断密码是否相同
	 *
	 * @param rawPassword     真实密码
	 * @param encodedPassword 加密后字符
	 * @return 结果
	 */
	public static boolean matchesPassword(String rawPassword, String encodedPassword) {
		BCryptPasswordEncoder passwordEncoder = new BCryptPasswordEncoder();
		return passwordEncoder.matches(rawPassword, encodedPassword);
	}

	/**
	 * 是否为管理员
	 * 
	 * @param userId 用户ID
	 * @return 结果
	 */
	public static boolean isAdmin(Long userId) {
		return userId != null && 1L == userId;
	}
}
